const gameNavTemplate = document.createElement('template');

// TODO update icons with new ones from Robert
const gameNavItems = [
  {
    id: 'spelling-bee',
    name: 'Spelling Bee',
    url: '/puzzles/spelling-bee?utm_source=wordle&utm_medium=referral&utm_campaign=wordle_nav',
    backgroundImage: `${'var(--spelling-bee)'}`,
  },
  {
    id: 'crossword',
    name: 'The Crossword',
    url: '/crosswords/game/daily?utm_source=wordle&utm_medium=referral&utm_campaign=wordle_nav',
    backgroundImage: `${'var(--daily)'}`,
  },
  {
    id: 'mini',
    name: 'The Mini',
    url: '/crosswords/game/mini?utm_source=wordle&utm_medium=referral&utm_campaign=wordle_nav',
    backgroundImage: `${'var(--mini)'}`,
  },
  {
    id: 'wordlebot',
    name: 'WordleBot: Your Daily Wordle Companion',
    url: '/interactive/2022/upshot/wordle-bot.html?utm_source=wordle&utm_medium=referral&utm_campaign=wordle_nav',
    backgroundImage: `${'var(--wordlebot)'}`,
  },
  {
    id: 'chess',
    name: 'Chess',
    url: '/spotlight/chess-puzzles?utm_source=wordle&utm_medium=referral&utm_campaign=wordle_nav',
    backgroundImage: `${'var(--chess)'}`,
  },
  {
    id: 'gameplay-stories',
    name: 'Gameplay Stories',
    url: '/column/wordplay?utm_source=wordle&utm_medium=referral&utm_campaign=wordle_nav',
  },
  {
    id: 'more-games',
    name: 'More Games',
    url: '/puzzles?utm_source=wordle&utm_medium=referral&utm_campaign=wordle_nav',
  },
];

const gameNavItemsHTML = gameNavItems
  .map((item) => {
    return `
    <a href=${item.url} id=${item.id}>
      <div class="nav-item" style="--hover-color: var(--color-nav-hover)">
        <span style="background-image: ${item.backgroundImage}; background-size: 20px;"class="nav-icon"></span>
          ${item.name} 
      </div>
    </a>
    `;
  })
  .join('');

const nytNavItems = [
  {
    id: 'nyt',
    name: 'The New York Times',
    url: 'https://www.nytimes.com/?utm_source=wordle&utm_medium=referral&utm_campaign=wordle_nav',
    backgroundImage: `${'var(--nyt)'}`,
  },
  {
    id: 'cooking',
    name: 'New York Times Cooking',
    url: 'https://cooking.nytimes.com',
    backgroundImage: `${'var(--cooking)'}`,
  },
  {
    id: 'wirecutter',
    name: 'New York Times Wirecutter',
    url: 'https://www.nytimes.com/wirecutter/?utm_source=wordle&utm_medium=referral&utm_campaign=wordle_nav',
    backgroundImage: `${'var(--wirecutter)'}`,
  },
  {
    id: 'athletic',
    name: 'The Athletic',
    url: 'https://theathletic.com/?utm_source=wordle&utm_medium=referral&utm_campaign=wordle_nav',
    backgroundImage: `${'var(--athletic)'}`,
  },
];

const nytNavItemsHTML = nytNavItems
  .map((item) => {
    return `
    <a href=${item.url} id=${item.id}>
      <div class="nav-item" style="--hover-color: var(--color-nav-hover)">
        <span style="background-image: ${item.backgroundImage}; background-size: 20px;"class="nav-icon"></span>
          ${item.name} 
      </div>
    </a>
    `;
  })
  .join('');

gameNavTemplate.innerHTML = `
  <style>
    .container {
      display: flex;
      flex-direction: column;
      align-items: left;
      justify-content: center;
    }
    h1 {
      font-weight: 700;
      font-size: 16px;
      letter-spacing: 0.5px;
      text-transform: uppercase;
      text-align: center;
      margin-bottom: 10px;
    }

    .nav-container {
      flex: 1;
    }

    .nav-container .nav {
      font-size: 36px;
      font-weight: 400;
      display: flex;
      align-items: center;
      justify-content: center;
      text-align: center;
      letter-spacing: 0.05em;
      font-variant-numeric: proportional-nums;
    }

    .nav-container .label {
      font-size: 12px;
      display: flex;
      align-items: center;
      justify-content: center;
      text-align: center;
    }

    .game-list, .nyt-list {
        list-style: none;
        color: var(--color-tone-1);
        padding: unset;
        margin: unset;
    }

    .nyt-list {
      margin-top: 5px;
      padding: 12px 0px;
      border-top: 1px solid #DCDCDC;
    }

    .nav-item {
        display: flex;
        justify-content: left;
        align-items: center;
        height: 40px;
        font-weight: 500;
        font-family: 'nyt-franklin';
        font-size: 16px;
        line-height: 16px;
        padding-left: 18px;
    }

    .nav-item:hover {
        background-color: var(--hover-color);
    }

    .nav-icon {
        padding-bottom: 2px;
        content: '';
        height: 20px;
        width: 28px;
        padding-right: 8px;
        display: inline-block;
        vertical-align: middle;
        background-repeat: no-repeat;
    }

    #nav {
      padding-bottom: 10px;
    }

    a {
        text-decoration: none;
        color: inherit;
    }

    .more-text {
        font-family: 'nyt-franklin-700';
        font-weight: 700;
        text-transform: uppercase;
        font-size: 12px;
        line-height: 12px;
        margin: 32px 0px 24px 0px;
        padding-left: 18px;
    }

    .nav-header {
        padding-top: 18px;
        padding-left: 18px;
    }

    .privacy {
      letter-spacing: .5px;
      font-family: 'nyt-franklin';
      position: absolute;
      bottom: 0;
      left: 0;
      right: 0;
      margin: 0px 25px 0px 17px;
      padding: 12px 0px;
      border-top: 1px solid #DCDCDC;
      color: var(--color-tone-1);
      font-size: 15px;
      text-align: right;
      display: flex;
      justify-content: space-between;
      align-items: flex-end;
    }
  </style>

  <div class="container">
    <span class="nav-header">
        <nyt-icon></nyt-icon>
    </span>
    <span class="more-text">More From New York Times Games</span>
    <div class="game-list">${gameNavItemsHTML}</div>
    <div class="nyt-list">${nytNavItemsHTML}</div>
    <div class="privacy">
      <a href="https://www.nytimes.com/privacy/privacy-policy" onmouseover="this.style.textDecoration='underline';" 
      onmouseout="this.style.textDecoration='none';">
        Privacy Policy
      </a>
    </div>
  </div>
`;

export class GameNav extends HTMLElement {
  gameApp;

  constructor() {
    super();
    this.attachShadow({ mode: 'open' });
  }

  connectedCallback() {
    this.shadowRoot.appendChild(gameNavTemplate.content.cloneNode(true));
  }
}

customElements.define('game-nav', GameNav);
