const notificationTemplate = document.createElement('template')
notificationTemplate.innerHTML = `
  <style>
    .toast {
      position: relative;
      margin: 16px;
      background-color: var(--color-tone-1);
      color: var(--color-tone-7);
      padding: 16px;
      border: none;
      border-radius: 4px;
      opacity: 1;
      transition: opacity 300ms cubic-bezier(0.645, 0.045, 0.355, 1);
      font-weight: 700;
    }
    .win {
      background-color: var(--color-correct);
      color: var(--tile-text-color);
    }
    .fade {
      opacity: 0;
    }
  </style>
  <div class="toast"></div>
`

const VISIBLE_TIME = 1000

export class GameToast extends HTMLElement {
  _duration
  constructor() {
    super()
    this.attachShadow({ mode: 'open' })
  }

  connectedCallback() {
    this.shadowRoot.appendChild(
      notificationTemplate.content.cloneNode(true),
    )
    const $toast = this.shadowRoot.querySelector('.toast')
    $toast.textContent = this.getAttribute('text')
    this._duration = this.getAttribute('duration') || VISIBLE_TIME
    // if (this.getAttribute('style')) {
    //   $toast.classList.add(this.getAttribute('style'));
    // }
    // Attributes are strings
    if (this._duration !== 'Infinity') {
      setTimeout(() => {
        $toast.classList.add('fade')
      }, this._duration)
    }

    $toast.addEventListener('transitionend', (e) => {
      this.parentNode.removeChild(this)
    })
  }
}

customElements.define('game-toast', GameToast)
