import { isMobile, browserDetect } from './deviceIdentifiers';

const FEEDBACK_LINK = 'mailto:nytgames@nytimes.com';

function capitalize(str) {
  return str.charAt(0).toUpperCase() + str.slice(1);
}

const createQueryString = function (obj) {
  const outStr = [];

  Object.keys(obj).forEach((p) => {
    outStr.push(`${encodeURIComponent(p)}=${encodeURIComponent(obj[p])}`);
  });

  return `?${outStr.join('&')}`;
};

export const getFeedbackLink = (emailSubject = 'Wordle Feedback') => {
  const ua = navigator.userAgent || navigator.vendor || window.opera;
  const tz = new Date().getTimezoneOffset();

  const body = `\r\n\r\n
--
Device summary:
Page: /games/wordle
Platform: ${isMobile() ? 'Web (Mobile)' : 'Web (Desktop)'} 
Browser: ${capitalize(browserDetect())}
Screen Resolution: ${window.screen.width} x ${window.screen.height}
Viewport Size: ${document.documentElement.clientWidth} x ${document.documentElement.clientHeight}
Timezone: ${`UTC${tz > 0 ? '' : '+'}${tz / -60}`}
Build: ${window.wordle?.hash}
  `;

  return FEEDBACK_LINK + createQueryString({ subject: emailSubject, body });
};
